#ifndef TRIANGLESTRIP_H
#define TRIANGLESTRIP_H
/*********************************************
 *
 * Cedric Pradalier
 * DEA 2000/2001 
 * INRIA Rhones Alpes
 * http://cedric.pradalier.free.fr/index.html
 * mail : cedric.pradalier@free.fr
 *
 * *******************************************/


extern "C" {
	#include "gpc.h"
}
#include "Polygon.h"
#include <Object.h>
#include "VtkPoly.h"

class TriangleStrip : public Object 
{
		private :
				gpc_tristrip * tristrip;
		public :
				TriangleStrip(Polygon * P);
				~TriangleStrip() {gpc_free_tristrip(tristrip);tristrip=NULL;}

				bool contains(double x,double y);

				// Collect les points du TriangleStrip pour les exporter
				// en PolyData pour Vtk (Visualization Tool Kit)
				void collectVtkPoints(VtkPoints & pts,VtkTriStrips & t,
						double theta, int ConnexPart);

};


#endif // TRIANGLESTRIP_H

